/**
 * @module shelljs
 */
import { RpsContext } from 'rpscript-interface';
import { ShellString, ShellArray } from 'shelljs';
export default class RpsShelljs {
    cat(ctx: RpsContext, opts: Object, ...filenames: string[]): Promise<ShellString>;
    cd(ctx: RpsContext, opts: {}, dir: string): Promise<void>;
    chmod(ctx: RpsContext, opts: {}, mode: string, file: string): Promise<void>;
    cp(ctx: RpsContext, opts: {}, ...location: string[]): Promise<void>;
    echo(ctx: RpsContext, opts: {}, item: any): Promise<any>;
    find(ctx: RpsContext, opts: {}, ...paths: string[]): Promise<ShellArray>;
    grep(ctx: RpsContext, opts: {}, regexFilter: string, ...files: string[]): Promise<ShellString>;
    head(ctx: RpsContext, opts: {}, ...file: string[]): Promise<ShellString>;
    ln(ctx: RpsContext, opts: {}, source: string, dest: string): Promise<void>;
    ls(ctx: RpsContext, opts: {}, ...path: string[]): Promise<ShellArray>;
    mkdir(ctx: RpsContext, opts: {}, ...dir: string[]): Promise<void>;
    mv(ctx: RpsContext, opts: {}, ...location: string[]): Promise<void>;
    pwd(ctx: RpsContext, opts: {}): Promise<ShellString>;
    rm(ctx: RpsContext, opts: {}, ...file: string[]): Promise<void>;
    sed(ctx: RpsContext, opts: {}, searchRegex: string, replacement: string, file: string): Promise<ShellString>;
    set(ctx: RpsContext, opts: {}, options: string): Promise<void>;
    sort(ctx: RpsContext, opts: {}, ...file: string[]): Promise<ShellString>;
    tail(ctx: RpsContext, opts: {}, ...file: string[]): Promise<ShellString>;
    tempdir(ctx: RpsContext, opts: {}): Promise<ShellString>;
    touch(ctx: RpsContext, opts: {}, ...file: string[]): Promise<void>;
    uniq(ctx: RpsContext, opts: {}, input: string, output?: string): Promise<ShellString>;
    which(ctx: RpsContext, opts: {}, command: string): Promise<ShellString>;
}
