"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module shelljs
 */
const rpscript_interface_1 = require("rpscript-interface");
const shelljs_1 = __importDefault(require("shelljs"));
let RpsShelljs = class RpsShelljs {
    // cat "filename" --options="-rf"
    cat(ctx, opts, ...filenames) {
        return __awaiter(this, void 0, void 0, function* () {
            let result = opts['options'] ? shelljs_1.default.cat(filenames) : shelljs_1.default.cat(opts['options'], filenames);
            return result;
        });
    }
    cd(ctx, opts, dir) {
        return __awaiter(this, void 0, void 0, function* () {
            let result = opts['options'];
            return shelljs_1.default.cd(dir);
        });
    }
    chmod(ctx, opts, mode, file) {
        return __awaiter(this, void 0, void 0, function* () {
            let result = opts['options'];
            if (result)
                return shelljs_1.default.chmod(result, mode, file);
            else
                return shelljs_1.default.chmod(mode, file);
        });
    }
    cp(ctx, opts, ...location) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            let dest = location.pop();
            if (options)
                return shelljs_1.default.cp(options, location, dest);
            else
                return shelljs_1.default.cp(location, dest);
        });
    }
    echo(ctx, opts, item) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                shelljs_1.default.echo(options, item);
            else
                shelljs_1.default.echo(item);
            return item;
        });
    }
    // @rpsAction({verbName:'exec'})
    // exec (ctx:RpsContext,opts:{}, functor:any[], fn:Function) : Promise<ExecOutputReturnValue> {
    //   shell.exec();
    // }
    find(ctx, opts, ...paths) {
        return __awaiter(this, void 0, void 0, function* () {
            return shelljs_1.default.find(paths);
        });
    }
    grep(ctx, opts, regexFilter, ...files) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.grep(options, regexFilter, files);
            else
                return shelljs_1.default.grep(regexFilter, files);
        });
    }
    head(ctx, opts, ...file) {
        return __awaiter(this, void 0, void 0, function* () {
            let num = opts['options'];
            if (num)
                return shelljs_1.default.head({ '-n': num }, file);
            else
                return shelljs_1.default.head(file);
        });
    }
    ln(ctx, opts, source, dest) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.ln(options, source, dest);
            else
                return shelljs_1.default.ln(source, dest);
        });
    }
    ls(ctx, opts, ...path) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.ls(options, path);
            else
                return shelljs_1.default.ls(path);
        });
    }
    mkdir(ctx, opts, ...dir) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.mkdir(options, dir);
            else
                return shelljs_1.default.mkdir(dir);
        });
    }
    mv(ctx, opts, ...location) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            let dest = location.pop();
            if (options)
                return shelljs_1.default.mv(options, location, dest);
            else
                return shelljs_1.default.mv(location, dest);
        });
    }
    pwd(ctx, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            return shelljs_1.default.pwd();
        });
    }
    rm(ctx, opts, ...file) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.rm(options, file);
            else
                return shelljs_1.default.rm(file);
        });
    }
    sed(ctx, opts, searchRegex, replacement, file) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.sed(options, searchRegex, replacement, file);
            else
                return shelljs_1.default.sed(searchRegex, replacement, file);
        });
    }
    set(ctx, opts, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return shelljs_1.default.set(options);
        });
    }
    sort(ctx, opts, ...file) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.sort(options, file);
            else
                return shelljs_1.default.sort(file);
        });
    }
    tail(ctx, opts, ...file) {
        return __awaiter(this, void 0, void 0, function* () {
            let num = opts['options'];
            if (num)
                return shelljs_1.default.tail({ '-n': num }, file);
            else
                return shelljs_1.default.tail(file);
        });
    }
    tempdir(ctx, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            return shelljs_1.default.tempdir();
        });
    }
    touch(ctx, opts, ...file) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.touch(options, file);
            else
                return shelljs_1.default.touch(file);
        });
    }
    uniq(ctx, opts, input, output) {
        return __awaiter(this, void 0, void 0, function* () {
            let options = opts['options'];
            if (options)
                return shelljs_1.default.uniq(options, input, output);
            else
                return shelljs_1.default.uniq(input, output);
        });
    }
    which(ctx, opts, command) {
        return __awaiter(this, void 0, void 0, function* () {
            return shelljs_1.default.which(command);
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'cat' })
], RpsShelljs.prototype, "cat", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'cd' })
], RpsShelljs.prototype, "cd", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'chmod' })
], RpsShelljs.prototype, "chmod", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'cp' })
], RpsShelljs.prototype, "cp", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'echo' })
], RpsShelljs.prototype, "echo", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'find' })
], RpsShelljs.prototype, "find", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'grep' })
], RpsShelljs.prototype, "grep", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'head' })
], RpsShelljs.prototype, "head", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'ln' })
], RpsShelljs.prototype, "ln", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'ls' })
], RpsShelljs.prototype, "ls", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'mkdir' })
], RpsShelljs.prototype, "mkdir", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'mv' })
], RpsShelljs.prototype, "mv", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'pwd' })
], RpsShelljs.prototype, "pwd", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'rm' })
], RpsShelljs.prototype, "rm", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'sed' })
], RpsShelljs.prototype, "sed", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'set' })
], RpsShelljs.prototype, "set", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'sort' })
], RpsShelljs.prototype, "sort", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'tail' })
], RpsShelljs.prototype, "tail", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'tempdir' })
], RpsShelljs.prototype, "tempdir", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'touch' })
], RpsShelljs.prototype, "touch", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'uniq' })
], RpsShelljs.prototype, "uniq", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'which' })
], RpsShelljs.prototype, "which", null);
RpsShelljs = __decorate([
    rpscript_interface_1.RpsModule("shelljs")
], RpsShelljs);
exports.default = RpsShelljs;
